<template>
    <v-container>
        <v-row>
            <v-col cols="12" sm="8" offset="2">
                <h1 class="font-weight-bold">DEVIS n°{{ devis.numDevis }} </h1>

                <v-row>
                    <v-col sm="7">
                        <v-text-field v-model="devis.adressWork" label="Adresse du chantier"></v-text-field>
                    </v-col>
                    <v-col sm="2" offset="3">
                        <v-select :items="dpt" value="devis.departement" v-model="devis.departement"
                                  label="Departement"/>
                    </v-col>
                </v-row>

                <ckeditor :editor="editor" v-model="devis.designation">
                </ckeditor>

                <v-divider class="divider"/>

                <div id="div-moyens">
                    <v-data-table :headers="headers" :items="moyensByDevis" hide-default-footer>
                        <template v-slot:item.quantity="props">
                            <v-edit-dialog :return-value.sync="props.item.quantity" @save="save">
                                {{ props.item.quantity }}
                                <template v-slot:input>
                                    <v-text-field
                                            v-model="props.item.quantity"
                                            label="Edit"
                                            single-line
                                            counter/>
                                </template>
                            </v-edit-dialog>
                        </template>
                        <template v-slot:item.duration="props">
                            <v-edit-dialog :return-value.sync="props.item.duration" @save="save">
                                {{ props.item.duration }}
                                <template v-slot:input>
                                    <v-text-field
                                            v-model="props.item.duration"
                                            label="Edit"
                                            single-line
                                            counter
                                    ></v-text-field>
                                </template>
                            </v-edit-dialog>
                        </template>
                        <template v-slot:item.price="props">
                            <v-edit-dialog :return-value.sync="props.item.price" @save="save">
                                {{ props.item.price }}
                                <template v-slot:input>
                                    <v-text-field
                                            v-model="props.item.price"
                                            label="Edit"
                                            single-line
                                            counter/>
                                </template>
                            </v-edit-dialog>
                        </template>
                        <template v-slot:item.actions="{ item }">
                            <v-icon small @click="deleteItem(item)">mdi-delete</v-icon>
                        </template>
                    </v-data-table>

                    <v-dialog v-model="addMoyenDialog" max-width="500px">
                        <template v-slot:activator="{ on }">
                            <v-btn color="green" id="btn-add-moyen" dark v-on="on">Ajouter une ligne</v-btn>
                        </template>
                        <v-card>
                            <v-card-title class="justify-center">
                                <span class="headline">Ajouter un moyen</span>
                            </v-card-title>
                            <v-card-text>
                                <v-container>
                                    <v-row>
                                        <v-col cols="12" sm="6" md="4">
                                            <v-select :items="moyens" item-text="title" item-value="title"
                                                      v-model="newMoyen.title" label="Designation" id="selectMoyen"
                                                      @input="inputSelect"></v-select>
                                        </v-col>
                                        <v-col cols="12" sm="6" md="4">
                                            <v-text-field v-model="newMoyen.quantity" label="Quantité(u)"
                                            ></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="6" md="4">
                                            <v-text-field v-model="newMoyen.duration" label="Durée(h)"
                                            ></v-text-field>
                                        </v-col>
                                    </v-row>
                                </v-container>
                            </v-card-text>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="brown" text @click="close">Annuler</v-btn>
                                <v-btn color="brown" text @click="add">Ajouter</v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </div>
                <v-btn @click="newForfait" id="btn-add-forfait" class="green" dark>Ajouter un forfait</v-btn>
                <div v-if="devis.forfaits && devis.forfaits.length !== 0">
                    <v-divider class="divider"/>
                    <p class="font-weight-bold">Liste des forfaits</p>
                    <v-expansion-panels accordion multiple>
                        <v-expansion-panel v-for="forfait in devis.forfaits" :key="forfait.id">
                            <v-expansion-panel-header>
                                <v-text-field :value="forfait.title" @click.stop=""
                                              label="Titre du forfait"></v-text-field>
                            </v-expansion-panel-header>
                            <v-expansion-panel-content>
                                <v-text-field :value="forfait.price" v-model.number="forfait.price" type="number"
                                              label="Prix du forfait(HT en euros)"></v-text-field>

                                <ckeditor :editor="editor" v-model="forfait.description">
                                </ckeditor>

                                <v-data-table :headers="headersForfait" :items="forfait.moyens" hide-default-footer>
                                    <template v-slot:item.actions="{ item }">
                                        <v-icon small @click="deleteMoyenForfait(item, forfait)">mdi-delete</v-icon>
                                    </template>
                                </v-data-table>
                                <div>
                                    <v-btn color="green" dark id="btn-delete-forfait" @click="deleteForfait(forfait)">
                                        Supprimer ce forfait
                                    </v-btn>
                                    <v-dialog v-model="addMoyenToForfaitDialog" max-width="500px">
                                        <template v-slot:activator="{ on }">
                                            <v-btn color="green" dark v-on="on">Ajouter une ligne</v-btn>
                                        </template>
                                        <v-card>
                                            <v-card-title class="justify-center">
                                                <span class="headline">Ajouter un moyen</span>
                                            </v-card-title>
                                            <v-card-text>
                                                <v-container>
                                                    <v-select :items="moyens" item-text="title" item-value="title"
                                                              label="Designation"
                                                              @input="inputSelectMoyenForfait"></v-select>

                                                </v-container>
                                            </v-card-text>
                                            <v-card-actions>
                                                <v-spacer></v-spacer>
                                                <v-btn color="brown" text v-on:click="addMoyenToForfaitDialog = false">
                                                    Annuler
                                                </v-btn>
                                                <v-btn color="brown" text @click="addToForfait(forfait)">Ajouter</v-btn>
                                            </v-card-actions>
                                        </v-card>
                                    </v-dialog>
                                </div>
                            </v-expansion-panel-content>
                        </v-expansion-panel>
                    </v-expansion-panels>


                </div>

                <v-divider class="divider"/>

                <div id="div-price-devis" class="text-right">
                    <p><b>TOTAL HT : </b> {{ this.totalHtLocalized }}</p>
                    <p><b>TVA 20 % : </b> {{ this.tva }}</p>
                    <p><b>TOTAL TTC : </b> {{ this.totalTtc }}</p>
                    <p><b>Soit en toutes lettres :</b> {{ this.totalLocalized |capitalize }}</p>
                </div>

                <div id="div-btn">
                    <v-btn color="green" dark v-on:click="download()">Télécharger</v-btn>
                    <v-btn color="green" id="btn-save-devis" dark v-on:click="saveDevisOnBdd()">Enregistrer</v-btn>
                </div>

            </v-col>
        </v-row>
        <v-snackbar v-model="snackbar" :color="this.snackbarColor" :timeout="2000">{{ this.snackbarText }}
        </v-snackbar>

    </v-container>
</template>

<script>
    import axios from "axios";
    import ClassicEditor from '@ckeditor/ckeditor5-build-classic';
    import CKEditor from '@ckeditor/ckeditor5-vue';
    import writeNumber from 'written-number';
    import {mapActions} from "vuex";

    export default {
        name: "DevisDetail",
        components: {
            ckeditor: CKEditor.component
        },
        beforeCreate() {
            let url;
            if (this.$route.params.id) {
                url = 'getDevis/' + this.$route.params.id;
            } else {
                url = 'getDevis';
            }
            axios.get(url).then((response) => {
                this.devis = response.data.devis;
                this.editorData = response.data.devis.designation;
                this.moyensByDevis = response.data.moyensByDevis;
                this.moyens = response.data.moyens;
            });
        },
        data: () => ({
            editor: ClassicEditor,
            editorConfig: {},
            editorData: "",
            snackbar: false,
            snackbarText: "",
            snackbarColor: "green",
            devis: null,
            addMoyenDialog: false,
            addMoyenToForfaitDialog: false,
            deleteDialog: false,
            dpt: ["22", "41", "29"],
            moyensByDevis: [],
            moyens: [],
            newMoyen: {
                title: '',
                quantity: 1,
                duration: 1,
                price: null,
                priceTotal: null,
                idMoyen: null,
            },
            defaultNewMoyen: {
                title: '',
                quantity: 1,
                duration: 1,
                price: null,
                priceTotal: null,
                idMoyen: null,
            },
            newMoyenForfait: {},
            headers: [
                {
                    text: "Moyen",
                    value: "title",
                },
                {
                    text: "Quantité(u)",
                    value: "quantity",
                    align: "center"
                },
                {
                    text: "Durée(h)",
                    value: "duration",
                    align: "center"

                },
                {
                    text: "Taux horaire",
                    value: "price",
                    align: "center"

                },
                {
                    text: "Montant total",
                    value: "priceTotal",
                    align: "center"
                },
                {
                    text: "Actions",
                    value: 'actions',
                    sortable: false,
                    align: "center"
                }
            ],
            headersForfait: [
                {
                    text: "Moyens mis à disposition",
                    value: 'title',
                },
                {
                    text: "Actions",
                    value: 'actions',
                    align: "center"
                }
            ]
        }),
        methods: {
            ...mapActions(['getClient']),
            save() {
                this.updatePriceTotalByMoyen();
            },
            close() {
                this.addMoyenDialog = false;
                setTimeout(() => {
                    this.newMoyen = Object.assign({}, this.defaultNewMoyen);
                    this.editedIndex = -1
                }, 300)
            },
            inputSelect(value) {
                let elem = this.moyens.find(element => element.title === value);
                this.newMoyen.idMoyen = elem.id;
            },
            inputSelectMoyenForfait(value) {
                let elem = this.moyens.find(element => element.title === value);
                this.newMoyenForfait = elem;
            },
            add() {
                if (this.newMoyen.title) {
                    this.moyensByDevis.push(this.newMoyen);
                    this.devis.moyen.push(this.newMoyen);
                    this.close();
                    this.priceHoraire();
                }
            },
            newForfait() {
                const newForfait = {
                    title: "Nouveau forfait",
                    description: "",
                    id: null,
                    moyens: [],
                    price: 0,
                };
                this.devis.forfaits.push(newForfait);
            },
            addToForfait(forfait) {
                forfait.moyens.push(this.newMoyenForfait);
                this.addMoyenToForfaitDialog = false;
                this.newMoyenForfait = {};
            },
            priceHoraire() {
                this.moyensByDevis.map((m) => {
                    let moyen = this.moyens.filter(n => n.title === m.title);
                    if (this.devis.departement === "41") {
                        m.price = moyen[0].priceCentre;
                    } else {
                        m.price = moyen[0].priceBzh;
                    }
                });
                this.updatePriceTotalByMoyen()
            },
            deleteItem(item) {
                this.$dialog.confirm('Êtes vous sur de supprimer cette ligne ?', {
                    okText: 'Oui',
                    CancelText: 'Annuler'
                }).then(() => {
                    const index = this.moyensByDevis.indexOf(item);
                    this.moyensByDevis.splice(index, 1);
                    if (item.id) axios.delete("/deleteMoyenByDevis/" + item.id);
                }).catch(() => {
                })
            },
            deleteMoyenForfait(item, forfait) {
                const index = forfait.moyens.indexOf(item);
                forfait.moyens.splice(index, 1);
                axios.delete("/deleteMoyenByForfait/" + forfait.id, {params: {itemId: item.id}}).then(() => {

                })
            },
            deleteForfait(forfait) {
                this.$dialog.confirm('Êtes vous sur de supprimer cette ligne ?', {
                    okText: 'Oui',
                    CancelText: 'Annuler'
                }).then(() => {
                    const index = this.devis.forfaits.indexOf(forfait);
                    this.devis.forfaits.splice(index, 1);
                    if (forfait.id) axios.delete("/deleteForfait/" + forfait.id);
                }).catch(() => {
                })
            },
            download() {

            },
            fetchDevis() {
                let url;
                if (this.$route.params.id) {
                    url = 'getDevis/' + this.$route.params.id;
                } else {
                    url = 'getDevis';
                }
                axios.get(url).then((response) => {
                    this.devis = response.data.devis;
                    this.editorData = response.data.devis.designation;
                    this.moyensByDevis = response.data.moyensByDevis;
                    this.moyens = response.data.moyens;
                });

            },
            saveDevisOnBdd() {
                let data = {
                    "devis": this.devis,
                    "moyens": this.moyensByDevis,
                    "id_client": this.$store.state.client.id
                };
                if (this.devis.id) {
                    this.snackbarText = "Devis mis à jour";
                } else {
                    this.snackbarText = "Devis créé";
                }
                axios.post("/saveDevis", JSON.stringify(data)).then((res) => {
                    this.getClient(this.$store.state.client.id);
                    console.log(res)
                    this.$route.params.id = res.data.id_devis
                    this.fetchDevis();
                    this.snackbarColor = "green";
                    this.snackbar = true;
                }).catch(() => {
                    this.snackbarText = "Une erreur est intervenue, avez-vous bien rempli les champs";
                    this.snackbarColor = "red";
                    this.snackbar = true;

                });
            },
            updatePriceTotalByMoyen() {
                this.moyensByDevis.map((m) => {
                    m.priceTotal = (m.duration * m.quantity) * m.price;
                });
            }
        },
        watch: {
            'devis.departement': function () {
                this.priceHoraire();
            }
        },
        computed: {
            totalHt: function () {
                let totalHt = 0;
                let totalMoyen = 0;
                this.moyensByDevis.map((m) => {
                    totalMoyen += m.priceTotal;
                });
                let totalForfait = 0;
                this.devis.forfaits.map((f) => {
                    if (f.price === '') {
                        f.price = 0;
                    }
                    totalForfait += f.price;
                });
                totalHt = totalMoyen + totalForfait;
                return totalHt;
            },
            //todo arrondi spelling
            totalHtLocalized: function () {
                return this.totalHt.toLocaleString('fr-FR', {style: 'currency', currency: 'EUR'})
            },
            tva: function () {
                return (this.totalHt * 0.2).toLocaleString('fr-FR', {style: 'currency', currency: 'EUR'});
            },
            totalTtc: function () {
                return (this.totalHt * 1.2).toLocaleString('fr-FR', {style: 'currency', currency: 'EUR'});
            },
            totalLocalized: function () {
                // let splitter = this.totalHt.split(
                let cents = ((this.totalHt * 1.2) % 1) * 100;
                let centsWord = "";
                if (cents == 1) {
                    centsWord = "et " + writeNumber(cents, {lang: 'fr'}) + " centime TTC"
                } else if (cents > 1) {
                    centsWord = " et " + writeNumber(cents, {lang: 'fr'}) + " centimes TTC"
                } else {
                    centsWord = " TTC"
                }
                return writeNumber((Math.floor(this.totalHt) * 1.2), {lang: 'fr'}) + " Euros " + centsWord;
            }
        },
        filters: {
            capitalize: function (value) {
                if (!value) return '';
                value = value.toString();
                return value.charAt(0).toUpperCase() + value.slice(1)
            }
        }
    }
</script>

<style scoped>
    .divider {
        margin-top: 50px;
        margin-bottom: 50px;
        background-color: rgba(0, 0, 0, 0.87) !important;
    }

    #btn-add-moyen {
        margin-top: 16px;
    }

    #btn-save-devis {
        margin-left: 24px;
    }

    #div-btn {
        margin-top: 24px;
    }

    #btn-delete-forfait {
        margin-right: 16px;
    }

    #btn-add-forfait {
        margin-top: 16px;
    }
</style>